// DFItemMenuChoice.cpp: Implementierung der Klasse CDFItemMenuChoice.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DFItemMenuChoice.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDFItemMenuChoice::CDFItemMenuChoice(NodeTypeID _type) : CDFItemBase(_type)
{

}

CDFItemMenuChoice::~CDFItemMenuChoice()
{

}

int CDFItemMenuChoice::Modify(CModifyData &modifyData)
{
	int i;
	unsigned int offs = modifyData.offsFlash, offsChild;
	CDFItemBase *item;
	TBedien bedien;

	// Daten von MenueEintrag uebernehmen
	TBMenueEintrag &menuEintrag = *(TBMenueEintrag*)&modifyData.file->m_flash[offs - FLASH_KONFIG_START];
	offs += sizeof(TBMenueEintrag);
	
	// Passwort ersetzen?
	if (modifyData.flags & SMDF_PASSWORD_MENU) {
		
		short password = LookupPassword(modifyData, menuEintrag.Name);
		if (password != -1) {

			menuEintrag.PassH = (password >> 8) & 0xFF;
			menuEintrag.PassL = password & 0xFF;
		}
	}

	// Name aendern?
	strcpy(menuEintrag.Name, LookupReplace(modifyData, menuEintrag.Name).c_str());

	// Daten der Aktion einlesen
	// Bedien einlesen
	for (i=0; i < (int)menuEintrag.EintragCnt; i++) {
		
		// Bedien einlesen
		offsChild = offs + i * sizeof(unsigned int);	// Pointer des Eintrags berechnen
		offsChild = *(unsigned int*)(&modifyData.file->m_flash[offsChild - FLASH_KONFIG_START]);
		ChangeOrderLong((unsigned char*)&offsChild);
		
		bedien = *(TBedien*)&modifyData.file->m_flash[offsChild - FLASH_KONFIG_START];

		switch(bedien.Typ) {
		
		case TB_MENUE: { 
				item = new CDFItemMenu();
				break;}
		
		case TB_DATENSATZ: {
				item = new CDFItemInputChain();
				break;}
#ifdef _WIN32
		default:
			ASSERT(0);
			break;
#endif
		}

		LinkEndChild(item);
		modifyData.offsFlash = offsChild;
		item->Modify(modifyData);
	}
		
	return 1;
}
